# I3DExClip Struct Reference
[External Interfaces]

Inheritance diagram for I3DExClip:

List of all members.

## Public Member Functions
virtual MicroTick MCCOMAPI | GetDuration ()=0
virtual int32 MCCOMAPI | GetAttributesCount ()=0
virtual I3DShParamInfo *MCCOMAPI | GetAttribute (I3DShAttributesSet *attributeSet, int32 index, I3DShParamInfo *lastParam)=0
virtual IDType MCCOMAPI | GetAttributeType (int32 paramIndex)=0
virtual void MCCOMAPI | GetAttributeValue (int32 paramIndex, TParamHolder &outValue)=0
virtual MCCOMErr MCCOMAPI | GetLoopOffset (TTransform3D &outOffset)=0
virtual void MCCOMAPI | GetAttributeTimeLineData (int32 paramIndex, I3DShParamTimeLine *dstTimeLine)=0
virtual void MCCOMAPI | GetClipIcon (TMCOffscreen *outOffscreen)=0
virtual const TAttributePath &MCCOMAPI | GetAttributePath (int32 paramIndex, I3DShAttributesSet *attributesSet)=0

## Detailed Description

There are two interfaces to access a component: The shell interface (I3DShClip) and the external interface (I3DExClip). You can get one from the other using QueryInterface.

See also:
  I3DShClip

## Member Function Documentation

virtual I3DShParamInfo* MCCOMAPI I3DExClip::GetAttribute | ( | I3DShAttributesSet * | attributeSet,
|  | int32 | index,
|  | I3DShParamInfo * | lastParam |
| ) |  |  | `[pure virtual]`

Returns an attribute of this clip.

Parameters:

  | attributeSet | Attributes set to be used.
  | index | Index of the parameter in this clip.
  | lastParam | The last valid param that

virtual const TAttributePath& MCCOMAPI I3DExClip::GetAttributePath | ( | int32 | paramIndex,
|  | I3DShAttributesSet * | attributesSet |
| ) |  |  | `[pure virtual]`

Returns the attribute path for specified attribute

Parameters:

  | paramIndex | Index of a parameter.
  | attributesSet | Attributes set (needed only for converting path to the new version).

virtual int32 MCCOMAPI I3DExClip::GetAttributesCount | ( |  | ) | `[pure virtual]`

Returns the number of attributes stored in this clip.

virtual void MCCOMAPI I3DExClip::GetAttributeTimeLineData | ( | int32 | paramIndex,
|  | I3DShParamTimeLine * | dstTimeLine |
| ) |  |  | `[pure virtual]`

Copy the param time line data into the given dstTimeLine.

Parameters:

  | paramIndex | The index of the attribute in the clip.
  | dstTimeLine | The time line.

virtual IDType MCCOMAPI I3DExClip::GetAttributeType | ( | int32 | paramIndex | ) | `[pure virtual]`

Get the type of a specified attribute.

Parameters:

  | paramIndex | The index of the attribute in the clip.

virtual void MCCOMAPI I3DExClip::GetAttributeValue | ( | int32 | paramIndex,
|  | TParamHolder & | outValue |
| ) |  |  | `[pure virtual]`

Get the value of one of the attribute.

Parameters:

  | paramIndex | The index of the attribute in the clip.
  | outValue | Returned value.

virtual void MCCOMAPI I3DExClip::GetClipIcon | ( | TMCOffscreen * | outOffscreen | ) | `[pure virtual]`

Returns the image to be used as the icon for the clip.

Parameters:

  | outOffscreen | The offscreen to fill.

virtual MicroTick MCCOMAPI I3DExClip::GetDuration | ( |  | ) | `[pure virtual]`

Returns the duration of the clip in micro tick.

virtual MCCOMErr MCCOMAPI I3DExClip::GetLoopOffset | ( | TTransform3D & | outOffset | ) | `[pure virtual]`

Get the transform offset that need to be added to the attributes set transform in the case of tree attributes set.

Parameters:

  | outOffset | The offset.

Implemented in TBasicClip.

The documentation for this struct was generated from the following file:

- I3DExClip.h